% DLCT-TpolBox
% Version 1.0  August-2015
% Copyright (C) Sara Soltani and Technical University of Denmark, 
% August 2015, ssol@dtu.dk, sarahsoltani@gmail.com

% 1. Matrix formulations

% Dictionary Learning Problem

% DicLear_M         - The function routine to learn a matrix dictionary
%                     with the given parameters.
% Lea_Algorithm_D2  - Performs the ADMM algorithm in k iterations
%                     for the dictionary learning problem in the Matrix
%                     form such that D in 2.
% Lea_Algorithm_Dinf - Performs the ADMM algorithm in k iterations
%                      for the dictionary learning problem in the Matrix
%                      form such that D in inf.

% The Mean Approximation Error

% MAE_M              - Computes the approximation error for the matrix
%                      formulation.

% The Reconstruction Problem

% RecM_Algorithm      - Solves the tomographic reconstruction problem
%                       in the matrix form for the asked test image
%                       by TFOCS.
% Linear_Opr          - Defines a linear operator for the tomographic
%                       reconstruction matrix formulation used by the
%                       TFOCS.
%-----------------------------------
% 2. Tensor formulations

% Dictionary Learning Problem

% DicLear_T           - The function routine to learn a tensor dictionary
%                       with the given parameters.
% Lea_Algorithm_T_D2  - Performs the ADMM algorithm in k iterations
%                       for the dictionary learning problem in the tensor
%                       form such that D in D2.
% Lea_Algorithm_T_Dinf - Performs the ADMM algorithm in k iterations
%                       for the dictionary learning problem in the tensor
%                       form such that D in Dinf.

% The Mean Approximation Error

% MAE_T                 - Computes the approximation error for the tensor
%                         formulation.
% Linear_TenLSQ_BestRec - The linear operator for the approximation error
%                        problem that is used by TFOCS.

% The Reconstruction Problem

% RecT_Algorithm      - Solves the tomographic reconstruction problem
%                       in the tensor form for the asked test image
%                       by TFOCS.
% Perm_Vec_Tensor     - Returns the permutation vector which gives a
%                       permutation to the solution.
% Linear_Opr_Tensor   - Defines a linear operator for the tomographic
%                       reconstruction tensor formulation used by
%                       TFOCS.
% prox_nuclearposl1   - Computes the prox operator for nuclear norm
%                       + l1 norm regularization iteratively using a
%                       Dykstra-like proximal algorithm.
%-----------------------------
% Demonstration Scripts.
% DL_demo            - Demo and example script for the dictionary
%                      learning (DL) problem in the matrix form.
% MAEM_demo          - Demo script file illustrating how to compute
%                      the approximation error of a test problem in
%                      the cone defined by the given dictionary.
% RecM_demo          - Demo script for the tomographic reconstruction
%                      problem in the matrix form.
% DL_Tensor_demo     - Demo script for the dictionary learning (DL)
%                      problem in the tensor form.
% MAET_demo          - Demo script file illustrates how to compute the
%                      approximation error of a test problem in the
%                      cone defined by the given tensor dictionary.
% RecT_demo          - Demo script for the tomographic reconstruction
%                      problem in the tensor form.

%---------------------------
% Auxiliary Routines.
% dykstra              - Finds a point in the intersection of two convex
%                        sets by iteratively projecting onto each of the
%                        convex sets.
% Perm_Vec             - Returns the permutation vector which gives a
%                        permutation to the solution.
% L_Matrix             - Returns the matrix L, used to penalize the
%                        block artifacts in the reconstruction formulation.

% tprod                - Computes the tensor-tensor product using FFTs
% tran                 - Returns the tensor transpose.
% fronorm              - Computes Frobenius norm of a tensor.

%---------------------------
% Display tools

% montageplot          - This function is a tool to illustrate the 
%                        dictionary elements as images.