function [ y ] = Linear_Opr( Alph,mode )

% The function Linear_Opr defines a linear operator for our tomographic 
% reconstruction formulation which is used by the TFOCS solver.

% Copyright (C) Sara Soltani and Technical University of Denmark, 
% August 2015, ssol@dtu.dk, sarahsoltani@gmail.com

global C P D Nr_Blocks

[m,n] = size(D);
m_A=size(C,1);

if mode==0
     y = [m_A,n*Nr_Blocks];
end

if mode==1
    AL = reshape(Alph, n, Nr_Blocks);
    Z = D*AL;
    z=Z(:);
    IP=zeros(length(P),1);
    IP(P)=1:length(P);
    y=C*z(IP);
    
end

if mode==2
    z1 = C'*Alph;
    z =  z1(P); 
    Z = reshape(z, m, Nr_Blocks);
    Y = D'*Z;
    y=Y(:);

end
end

